/***************************************************************************/
/**                                                                       **/
/**              MODULAR-4 library for SPB module M-AD16-4                **/
/**                                                                       **/
/**  This file contains routines for Borland C++/3.1 to allow the user,   **/
/**  to write programs for the MODULAR-4 in "C" 			  **/
/**                                                                       **/
/**                             Version 1.B.                              **/
/**                                                                       **/
/**             Last change      : 28.11.1996                             **/
/**             Adaptation to Windows 95, Windows NT and OS/2		  **/
/**                                                                       **/
/**                             Version 1.A.                              **/
/**                                                                       **/
/**             Last change      : 02.05.1995                             **/
/**                                                                       **/
/**                         Author : A.H.+H.K.                            **/
/**                         Status : O.K.               		  **/
/**                                                                       **/
/**                                                                       **/
/**                                                                       **/
/** This library was tested with Borland C++ Version 3.1.	          **/
/**                                                                       **/
/** No parameters are checked.						  **/
/**                                                                       **/
/**                                                                       **/
/**                                                                       **/
/**               (c) SORCUS Computer GmbH 1995/1996			  **/
/**                                                                       **/
/***************************************************************************/

/* The switches for the library are set in the configuration files of Pascal
   (*.TP file) und C (project-file). They can also be set in this source file:

   Then the following #defines have to exist:

   If you use Pascal, #define BORLAND_PASCAL has to be included (default is C).

   If the library shall be used as realtime library on the MODULAR-4/486
   #define ML8 and #define ML8RT have to be included (default is PC library).

   If you work with Windows, this is detected by the compiler. No #defines have
   to be included.
*/


#include "m043_lib.h"

	/* Static Arrays                     */
 STATIC short  m043gain[ANZ_MOD][8];
 STATIC short  m043offset[ANZ_MOD][8];
 STATIC ushort m043settle[ANZ_MOD];
 STATIC short  m043range[ANZ_MOD];
 STATIC byte   m043convtype[ANZ_MOD];

#if defined (__DLL__) && !defined (__OS2__)/* if module DLL shall be generated  */

#include <windows.h>

HANDLE   hInst;

#pragma argsused

int far pascal LibMain(hInstance, wDataSeg, wHeapSize, lpszCmdLine)
HANDLE  hInstance;                     /* Instance of DLL                   */
WORD    wDataSeg;                      /* Data segment                      */
WORD    wHeapSize;                     /* Size of Heap  	            */
LPSTR   lpszCmdLine;                   /* Pointer to command line           */

{
 hInst = hInstance;

 if (wHeapSize > 0) UnlockData(0);

 return(1);
}

#endif  /* __DLL__ */

#ifndef BORLAND_PASCAL

short loushort(long w)
{
  return((w < 0) ? -(-w & 0x00003FFF) : (w & 0x00003FFF));
}

short hiushort(long w)
{
  return((w < 0) ? ((short) -(-w >> 14)) : ((short) (w >> 14)));
}
#else
extern short pascal loushort(long w);
extern short pascal hiushort(long w);
#endif

/* Delay, min. 1 microsecond
*/
void m043_delay(int m)
{
 int i;
 for (i=0; i<m; i++) {
   mlx_out_port(0x3F,0);		/* Delay min. 250 ns */
   mlx_out_port(0x3F,0);
   mlx_out_port(0x3F,0);
   mlx_out_port(0x3F,0);
 }
}

/* Init library with EEPROM-values */
MLXAPI void EXPORT m043_bib_startup(byte micro_slot)
{
 ushort w;
 short  i, endm, m;
 byte   mode;
				       /* Check, whether module extender is */
				       /* placed at slot 1                  */
 if (lobyte(mlx_read_eeprom(1, 0)) == 0x29) endm = ANZ_MOD;
 else endm = 5;                        /* 4 slots                           */

 for (m = 1; m < endm; m++)            /* Check all slots                   */
   if(lobyte(mlx_read_eeprom(m, 0)) == 0x2B)
     {                                 /* Right module = 43 = 0x2B          */
      for (i = 0; i < 8; i++)
	{                              /* Read correction values            */
	 w = mlx_read_eeprom(m, 4 + i * 2);
	 m043offset[m][i]   = (short)w;/* Offset                            */
	 w = mlx_read_eeprom(m, 5 + i * 2);
	 m043gain[m][i] = (short)w;    /* Gain                              */
	}

				       /* get AD-Converter Type             */
      w = mlx_read_eeprom(m, 2) & 0x000F;
      if(w < 4)                        /* 16 Bit ADC                        */
	m043convtype[m] = 16;
      else                             /* 12 Bit ADC                        */
	m043convtype[m] = 12;

				       /* get jumper-config (range)         */
      w = mlx_read_eeprom(m, 3) & 0x01FF;
      switch((int)w)
	{
	 case 0x00E4 :                 /* -10...+10V range                  */
		       m043range[m] = 3; break;
	 case 0x0131 :                 /*  -5... +5V range                  */
		       m043range[m] = 2; break;
	 case 0x0119 :                 /*   0...+10V range                  */
		       m043range[m] = 1; break;
	 case 0x0107 :                 /*   0... +5V range                  */
		       m043range[m] = 0; break;
	 default     :
			  m043range[m] = 3; break;
	}

      w = mlx_read_eeprom(m, 20 + m043range[m]);
      m043settle[m] = (ushort)w;       /* Settle-Time for this range        */
				       /* M-AD16-4 Mode, no Timer-A         */
      mode = 0x01;
				       /* Converter Type                    */
      if(m043convtype[m] == 12) mode |= 0x08;
				       /* Output Format                     */
      if(m043range[m] >= 2) mode |= 0x10;
				       /* Write Mode-Register               */
      micro_slot = m;
      mlx_out_port(MBASIS + M043_SET_MODE_REG, mode);

				       /* Set Settle-Timer                  */
      mlx_out_port(MBASIS + M043_SET_SETTLE_TIMELOW,
	      lobyte(m043settle[m]));
      mlx_out_port(MBASIS + M043_SET_SETTLE_TIMEHIGH,
	      hibyte(m043settle[m]));
     }
   else
     {
      for(i = 0; i < 15; i++)
	{                              /* Init configuration                */
	 m043gain[m][i]   = 0;         /* Gain 		                    */
	 m043offset[m][i] = 0;         /* Offset                            */
	}
      for(i = 0; i < 4; i++)
	m043settle[m] =  0;            /* Settle-Time                       */
      m043convtype[m] = 16;            /* 16 Bit ADC Mode                   */
      m043range[m]    =  3;            /* -10...+10V range                  */
     }
}


/* Set correction values        */
/* into globals                 */
MLXAPI void EXPORT m043_set_correct_values(byte micro_slot, byte channel,
				    short corgain, short coroffset,
				    ushort settle)
{
				       /* Set correction for gain           */
 m043gain[micro_slot][channel]   = corgain;
				       /* Set correction for offset         */
 m043offset[micro_slot][channel] = coroffset;
				       /* Set settle                        */
 m043settle[micro_slot]   = settle;
				       /* Set Settle-Timer                  */
 mlx_out_port(MBASIS + M043_SET_SETTLE_TIMELOW,
	      lobyte(m043settle[micro_slot]));
 mlx_out_port(MBASIS + M043_SET_SETTLE_TIMEHIGH,
	      hibyte(m043settle[micro_slot]));
}


/* Read correction values       */
/* from globals                 */
MLXAPI void EXPORT m043_get_correct_values(byte micro_slot, byte channel,
				    short *corgain, short *coroffset,
				    ushort *settle, byte *range,
				    byte *convtype)
{                                      /* Read correction for gain          */
 *corgain   = m043gain[micro_slot][channel];
				       /* Read correction for offset        */
 *coroffset = m043offset[micro_slot][channel];
				       /* Read settle time                  */
 *settle    = m043settle[micro_slot];
				       /* Read range                        */
 *range     = m043range[micro_slot];
				       /* Read AD-converter type            */
 *convtype  = m043convtype[micro_slot];
}


/* Configure module like EEPROM */
MLXAPI void EXPORT m043_set_conf_eeprom(byte micro_slot)
{
 m043_bib_startup(micro_slot);         /* Load startup values               */
}

/* Read voltage of A/D-channel  */
MLXAPI void EXPORT m043_in(byte micro_slot, byte channel, byte mode, long *data_var)
{
 ushort cnt, format, t;
 long sum;
 byte status;

#ifdef ML8
#else
 byte hi, low;
#endif
				       /* Check Output Format               */
				       /* Offset Binary ? format = 0        */
 format = (mlx_in_port(MBASIS + M043_READ_MODE_REG) & 0x10);

#ifdef ML8

 if(((byte)mlx_in_port(MBASIS + M043_READ_STATUSBYTE) & 0x07) != channel)
   {
				       /* Set Channel...starts Conversion   */
    mlx_out_port(MBASIS + M043_SET_CHANNEL_REG, channel);
   }
 else
   mlx_out_port(MBASIS + M043_START_CONVERT, 0x00);

				       /* Wait for End of Conversion        */
 t = 0;                                /* Read Status of Conversion         */
 do {
   status = mlx_in_port(MBASIS + M043_READ_STATUSBYTE);
   m043_delay(1);		       /* Wait 1 microsecond */
   t -= 1;
   } while (((status & 0x80) != 0x80)  && (t < 500));

 if(mode != 1)                         /* Conversions                   */
   {
    switch (mode) {
      case 2 : cnt = 8;  break;
      case 3 : cnt = 16; break;
      case 4 : cnt = 32; break;
      case 5 : cnt = 64; break;
      default : cnt = 1; break;
      }
    sum = 0L;
    do{                                /* next Conversion, previous Result  */
       mlx_out_port(MBASIS + M043_START_CONVERT, 0x00);
				       /* Wait for End of Conversion        */
       t = 0;                                /* Read Status of Conversion         */
       do {
	 status = mlx_in_port(MBASIS + M043_READ_STATUSBYTE);
	 m043_delay(1);		       /* Wait 1 microsecond */
	 t -= 1;
	 } while (((status & 0x80) != 0x80)  && (t < 500));

       if(format == 0)                 /* Offset Binary = unsigned short    */
	 sum += (ushort)ml8_in16_port(MBASIS + M043_READ_AD16);
       else                            /* 2's Complement = signed short     */
	 sum += (short)ml8_in16_port(MBASIS + M043_READ_AD16);
       }while(--cnt > 0);


     switch (mode) {
       case 2 : *data_var = (hiushort(sum) * 2048) + (loushort(sum) >> 3); break;
       case 3 : *data_var = (hiushort(sum) * 1024) + (loushort(sum) >> 4); break;
       case 4 : *data_var = (hiushort(sum) *  512) + (loushort(sum) >> 5); break;
       case 5 : *data_var = (hiushort(sum) *  256) + (loushort(sum) >> 6); break;
       default : *data_var = sum; break;
       }

    }
  else				       /* Read Result                       */
    if(format == 0)                    /* Offset Binary = unsigned short    */
      *data_var = (ushort) ml8_in16_port(MBASIS + M043_READ_AD16);
    else                               /* 2's Complement = signed short     */
      *data_var = (short) ml8_in16_port(MBASIS + M043_READ_AD16);


#else                                  /* ML4/ML5                           */

  if(((byte)mlx_in_port(MBASIS + M043_READ_STATUSBYTE) & 0x07) != channel)
    {
				       /* Set Channel...starts Conversion   */
     mlx_out_port(MBASIS + M043_SET_CHANNEL_REG, channel);
    }
  else
    mlx_out_port(MBASIS + M043_START_CONVERT, 0x00);

				       /* Wait for End of Conversion        */
  t = 0;                                /* Read Status of Conversion         */
  do {
    status = mlx_in_port(MBASIS + M043_READ_STATUSBYTE);
    m043_delay(1);		       /* Wait 1 microsecond */
    t -= 1;
    } while (((status & 0x80) != 0x80)  && (t < 500));

  if(mode != 1)                        /* next conversion, previous result  */
    {
    switch (mode) {
      case 2 : cnt = 8;  break;
      case 3 : cnt = 16; break;
      case 4 : cnt = 32; break;
      case 5 : cnt = 64; break;
      default : cnt = 1; break;
      }
     sum = 0L;
     do{
	mlx_out_port(MBASIS + M043_START_CONVERT, 0x00);
				       /* Wait for End of Conversion        */
	t = 0;                         /* Read Status of Conversion         */
	do {
	  status = mlx_in_port(MBASIS + M043_READ_STATUSBYTE);
	  m043_delay(1);		       /* Wait 1 microsecond */
	  t -= 1;
	  } while (((status & 0x80) != 0x80)  && (t < 500));
	low = mlx_in_port(MBASIS + M043_READ_ADLOW);
	hi  = mlx_in_port(MBASIS + M043_READ_ADHIGH);
	if(format == 0)                /* Offset Binary = unsigned short    */
	  sum += (ushort)(low | (hi << 8));
	else                           /* 2's Complement = signed short     */
	  sum += (short)(low | (hi << 8));
       }while(--cnt > 0);
     switch (mode) {
       case 2 : *data_var = (hiushort(sum) * 2048) + (loushort(sum) / 8); break;
       case 3 : *data_var = (hiushort(sum) * 1024) + (loushort(sum) / 16); break;
       case 4 : *data_var = (hiushort(sum) *  512) + (loushort(sum) / 32); break;
       case 5 : *data_var = (hiushort(sum) *  256) + (loushort(sum) / 64); break;
       default : *data_var = sum; break;
       }

    }
  else				       /* Read Result                       */
    {
     low = mlx_in_port(MBASIS + M043_READ_ADLOW);
     hi  = mlx_in_port(MBASIS + M043_READ_ADHIGH);
     *data_var = (hi << 8) | low;
    }

#endif
}


