#ifndef _m043_lib_
#define _m043_lib_
/***************************************************************************/
/**                                                                       **/
/**              MODULAR-4 library for SPB module M-AD16-4                **/
/**                                                                       **/
/**                             Version 1.B.                              **/
/**                                                                       **/
/**             Last change      : 28.11.1996                             **/
/**             Adaptation to Windows 95, Windows NT and OS/2		  **/
/**                                                                       **/
/**                             Version 1.A.                              **/
/**                                                                       **/
/**  This file contains routines for Borland C++/3.1 to allow the user,   **/
/**  to write programs for the MODULAR-4 in "C"                           **/
/**                                                                       **/
/**             Last change      : 02.05.1995                             **/
/**                                                                       **/
/**                         Author : A.H.+H.K.                            **/
/**                         Status : ----                                 **/
/**                                                                       **/
/**                                                                       **/
/** Special comments:                                                     **/
/**                                                                       **/
/** This library was tested with Borland C++ Version 3.1.                 **/
/**                                                                       **/
/** No parameters are checked.                                            **/
/**                                                                       **/
/**                                                                       **/
/**                                                                       **/
/**               (c) SORCUS Computer GmbH 1995/1996                      **/
/**                                                                       **/
/***************************************************************************/

/* The switches for the library are set in the configuration files of Pascal
   (*.TP file) und C (project-file). They can also be set in this source file:

   Then the following #defines have to exist:

   If you use Pascal, #define BORLAND_PASCAL has to be included (default is C).

   If the library shall be used as realtime library on the MODULAR-4/486
   #define ML8 and #define ML8RT have to be included (default is PC library).

   If you work with Windows, this is detected by the compiler. No #defines have
   to be included.
*/

#include <MODULE.H>
				       /* Modul-Basisadresse                             */
#define MBASIS  micro_slot_basis[micro_slot]

#define M043_START_CONVERT       0x01  /* Start/Convert                    */
#define M043_READ_AD16           0x02  /* Read AD-Result (16 Bit)          */
#define M043_READ_ADHIGH         0x05  /* Read AD-Result (Highbyte)        */
#define M043_READ_ADLOW          0x06  /* Read AD-Result (Lowbyte)         */
#define M043_READ_STATUSBYTE     0x08  /* Read AD-Status                   */
#define M043_SET_CHANNEL_REG     0x08  /* Set Channel 0..7                 */
#define M043_SET_CHANNEL_0       0x10  /* Set Channel 0                    */
#define M043_SET_CHANNEL_1       0x11  /* Set Channel 1                    */
#define M043_SET_CHANNEL_2       0x12  /* Set Channel 2                    */
#define M043_SET_CHANNEL_3       0x13  /* Set Channel 3                    */
#define M043_SET_CHANNEL_4       0x14  /* Set Channel 4                    */
#define M043_SET_CHANNEL_5       0x15  /* Set Channel 5                    */
#define M043_SET_CHANNEL_6       0x16  /* Set Channel 6                    */
#define M043_SET_CHANNEL_7       0x17  /* Set Channel 7                    */
#define M043_SET_SETTLE_TIMELOW  0x18  /* Set Settle-Timer Lowbyte (8Bit)  */
#define M043_SET_SETTLE_TIMEHIGH 0x19  /* Set Settle-Timer Highbyte (8Bit) */
#define M043_SET_SETTLE_TIME16   0x1A  /* Set Settle-Timer word (16 Bit)   */
#define M043_SET_MODE_REG        0x1C  /* Set Mode Register (8Bit)         */
#define M043_READ_MODE_REG       0x1C  /* Read Mode Register (8Bit)        */
#define M043_RESET_MODUL         0x1D  /* Reset-Modul                      */
#define M043_READ_FPGA_VERSION   0x1E  /* Read FPGA-Version (8Bit)         */

#define TIMEOUT             100        /* Timeout between I/O-calls        */
#define M043_POL             16        /* Offset Binary/2'sComplement      */
#define M043_ADC              8        /* ADC 16/12 Bit                    */
#define M043_TIMERA           4        /* Timer-A dis./enabled             */
#define M043_SETTLE           2        /* Settle-T. 1:4/1:1                */
#define M043_M168             1        /* M-AD16-8/4 switch                */


#define M043_UPP_5V           0        /* Unipolar: 0 bis 5 V              */
#define M043_UPP_10V          1        /* Unipolar: 0 bis 10 V             */
#define M043_BP_5V            2        /* Bipolar: +/- 5 V                 */
#define M043_BP_10V           3        /* Bipolar: +/- 10 V                */

#if defined(__cplusplus)
extern "C" {
#endif



/* Init module library                */
MLXAPI void EXPORT m043_bib_startup(byte micro_slot);

/* Config module as defined in EEPROM */
MLXAPI void EXPORT m043_set_conf_eeprom(byte micro_slot);

/* Set correct values                 */
MLXAPI void EXPORT m043_set_correct_values(byte micro_slot, byte channel,
				    short corgain, short coroffset,
				    ushort settle);

/* Read correct values (from EEPROM)  */
MLXAPI void EXPORT m043_get_correct_values(byte micro_slot, byte channel,
				    short *corgain, short *coroffset,
				    ushort *settle, byte *range,
				    byte *convtype);

/* Read analog input                  */
/* returns 16 Bit integer             */
MLXAPI void EXPORT m043_in(byte micro_slot, byte channel, byte mode, long *data_var);


#if defined(__cplusplus)
} /*  End of block extern "C" */
#endif

#endif
