{$C MOVEABLE DEMANDLOAD DISCARDABLE}
(***************************************************************************)
(**                                                                       **)
(**              MODULAR-4 library for SPB module M-AD16-4                **)
(**                                                                       **)
(**  This file contains routines for Borland Pascal to allow the user,    **)
(**  to write programs for the MODULAR-4 in "Pascal" 			  **)
(**                                                                       **)
(**                             Version 1.B.                              **)
(**                                                                       **)
(**             Last change      : 28.11.1996                             **)
(**             Adaptation to Windows 95, Windows NT and OS/2             **)
(**                                                                       **)
(**                         Author : A.H. + H.K.                          **)
(**                             Version 1.A.                              **)
(**                                                                       **)
(**             Last change      : 28.04.1995                             **)
(**                                                                       **)
(**                         Author : A.H. + H.K.                          **)
(**                         Status : O.K.  		                  **)
(**                                                                       **)
(**                                                                       **)
(** Special comments: 							  **)
(**                                                                       **)
(** This library was tested with Borland Pascal Version 7.0.	          **)
(**                                                                       **)
(** No parameters are checked.						  **)
(**                                                                       **)
(**                                                                       **)
(**                                                                       **)
(**               (c) SORCUS Computer GmbH 1995                           **)
(**                                                                       **)
(***************************************************************************)

(* The switches for the library are set in the configuration files of Pascal
   (*.TP file) und C (project-file). They can also be set in this source file:

   Then the following #defines have to exist:

   If you use Pascal, #define BORLAND_PASCAL has to be included (default is C).

   If the library shall be used as realtime library on the MODULAR-4/486
   #define ML8 and #define ML8RT have to be included (default is PC library).

   If you work with Windows, this is detected by the compiler. No #defines have
   to be included.
*)

unit m043_lib;
interface
uses
{$IFDEF ML8}
        {$IFDEF Windows}
                wml8bib;        (* Include library for MODULAR-4/486 under Windows *)
        {$ELSE}
               {$IFDEF ML8RT}
                       ml8rtbib;    (* Include library for MODULAR-4/486 realtime programs *)
               {$ELSE}
                       ml8bib;      (* Include library for MODULAR-4/486 under DOS *)
               {$ENDIF}
        {$ENDIF}
{$ELSE}
        {$IFDEF Windows}
                wml4bib,wml4deb;    (* Include library for MODULAR-4/Z80 under WINDOWS *)
        {$ELSE}
                ml4bib,ml4deb;      (* Include library for MODULAR-4/Z80 under DOS *)
        {$ENDIF}
{$ENDIF}

{$IFDEF Windows}
const
     M043DLL = 'M043_LIB';
{$ENDIF}
const
     M043_UPP_5V            = 0;                           (* Unipolar: 0 to 5 V            *)
     M043_UPP_10V           = 1;                           (* Unipolar: 0 to 10 V           *)
     M043_BP_5V             = 2;                           (* Bipolar: +/- 5 V              *)
     M043_BP_10V            = 3;                           (* Bipolar: +/- 10 V             *)

function hiushort(w: longint):integer;
function loushort(w: longint):integer;

(* Init module library *)

procedure m043_bib_startup(micro_slot: byte);

(* Configure module like EEPROM *)

procedure m043_set_conf_eeprom(micro_slot: byte);

(* Set correction values *)

procedure m043_set_correct_values(micro_slot, channel: byte;
                                      corgain, coroffset: integer;
                                      settle: word);

(* Read correction values *)

procedure m043_get_correct_values(micro_slot, channel: byte;
                                  var corgain, coroffset: integer;
                                  var settle: word;
                                  var range, convtype: byte);

(* Read voltage at analogue input *)

procedure m043_in(micro_slot, channel: byte; mode: byte; var datbyte: longint);



implementation

{$IFNDEF Windows}           (* If no DLL is generated, a .OBj file has to be included *)

{$L m043_lib.obj}

{$ENDIF}

function hiushort(w: longint):integer;
begin
 if w < 0 then
   hiushort := -(-w shr 14)
 else
   hiushort := (w shr 14);
end;

function loushort(w: longint):integer;
begin
  if w < 0 then
    loushort := -w and $00003FFF
  else
    loushort := w and $00003FFF;
end;

(* Init module library *)

procedure m043_bib_startup(micro_slot: byte);
          external {$IFDEF Windows} M043DLL {$ENDIF};

(* Configure module like EEPROM *)

procedure m043_set_conf_eeprom(micro_slot: byte);
          external {$IFDEF Windows} M043DLL {$ENDIF};

(* Set correction values *)

procedure m043_set_correct_values(micro_slot, channel: byte;
                                      corgain, coroffset: integer;
                                      settle: word);
          external {$IFDEF Windows} M043DLL {$ENDIF};

(* Read correction values *)

procedure m043_get_correct_values(micro_slot, channel: byte;
                                  var corgain, coroffset: integer;
                                  var settle: word;
                                  var range, convtype: byte);
          external {$IFDEF Windows} M043DLL {$ENDIF};

(* Read voltage at analogue input *)

procedure m043_in(micro_slot, channel: byte; mode: byte; var datbyte: longint);
          external {$IFDEF Windows} M043DLL {$ENDIF};


begin
end.